<template lang="pug">
  .container-detail
    button.icon(
      v-for='(biomechanism, index) in detail.need'
      :class='{"icon-not-pressed": !detail.installed[index]}'
      :disabled='isHaveDetails(detail, index)'
      @click='handleClickDetail(detail, index)'
    )
      svg.svg(v-if='checkBiomechanism(detail.alias, index)' width='36' height='24' fill='none' xmlns='http://www.w3.org/2000/svg')
        path.path(d='M12.286 9.296a.612.612 0 01-.841-.222.63.63 0 01.218-.855l2.509-1.5a.61.61 0 01.841.221.63.63 0 01-.218.856l-2.509 1.5z' fill='#FF7F22')
        path.path(fill-rule='evenodd' clip-rule='evenodd' d='M35.99 14.343l-.505-2.935a.62.62 0 00-.533-.512l-2.64-.321-.917-1.723c.296-.516.394-1.13.267-1.72a2.39 2.39 0 00-1.148-1.574l-2.546-1.452a.61.61 0 00-.837.24.63.63 0 00.236.85l2.546 1.452c.586.334.756 1.112.359 1.668a1.118 1.118 0 01-1.29.402L21.73 6.05a3.324 3.324 0 001.424-3.254l2.033 1.158a.613.613 0 00.837-.24.63.63 0 00-.235-.85L21.796.588a3.254 3.254 0 00-.557-.314 3.172 3.172 0 00-2.48-.042 3.245 3.245 0 00-1.784 1.754c-.082.193-.145.39-.189.59L5.2 7.755a5.32 5.32 0 00-4.227 2.3.632.632 0 00.148.87.608.608 0 00.857-.15 4.093 4.093 0 013.344-1.772h.02c2.259.004 4.095 1.874 4.095 4.172 0 2.3-1.84 4.172-4.104 4.172-2.262 0-4.103-1.872-4.103-4.172 0-.11.005-.227.016-.358a.622.622 0 00-.561-.676.618.618 0 00-.664.57 5.442 5.442 0 002.641 5.155L5.472 24h1.355l-2.52-5.503a5.261 5.261 0 004.869-1.565L12.37 24h1.353l-3.662-8.105 9.738-9.227 8.764 3.225c.259.096.527.141.794.141.39 0 .775-.098 1.118-.284l.756 1.42-1.18 2.422a.632.632 0 00.13.734l2.14 2.035a.607.607 0 00.87-.029.632.632 0 00-.03-.883l-1.806-1.718.926-1.901 2.072.252.427 2.476c.058.34.377.568.711.508a.624.624 0 00.5-.723zM19.953 1.252a2.01 2.01 0 011.869 1.294c.554 1.425-.579 2.943-2.078 2.786-1.238-.18-1.895-1.218-1.796-2.237a2.026 2.026 0 012.005-1.843zM7.354 8.158l9.419-4.211a3.29 3.29 0 001.69 2.279l-7.815 7.404a5.431 5.431 0 00-3.294-5.472z' fill='#FF7F22')
        path.path(d='M10.385 24l-1.847-4.086a.61.61 0 00-.815-.307.63.63 0 00-.302.829L9.031 24h1.354z' fill='#FF7F22')
        path.path(fill-rule='evenodd' clip-rule='evenodd' d='M8.051 13.176c0-1.524-1.22-2.763-2.718-2.763s-2.717 1.24-2.717 2.763 1.219 2.763 2.717 2.763c1.499 0 2.718-1.24 2.718-2.763zm-4.206 0c0-.835.668-1.513 1.488-1.513s1.488.679 1.488 1.513c0 .834-.667 1.513-1.488 1.513-.82 0-1.488-.679-1.488-1.513z' fill='#FF7F22')
      svg.svg(v-if='checkProcessor(detail.alias, index)' width='24' height='24' fill='none' xmlns='http://www.w3.org/2000/svg')
        path.path(d='M20.4 2.274V0h-.8v2.032A2.82 2.82 0 0019.2 2h-.8V0h-.8v2h-1.2V0h-.8v2h-1.2V0h-.8v2h-1.2V0h-.8v2h-1.2V0h-.8v2H8.4V0h-.8v2H6.4V0h-.8v2h-.8a2.82 2.82 0 00-.4.032V0h-.8v2.274A2.814 2.814 0 002.274 3.6H0v.8h2.032A2.82 2.82 0 002 4.8v.8H0v.8h2v1.2H0v.8h2v1.2H0v.8h2v1.2H0v.8h2v1.2H0v.8h2v1.2H0v.8h2v1.2H0v.8h2v.8c.001.134.012.268.032.4H0v.8h2.274c.277.58.745 1.049 1.326 1.326V24h.8v-2.032c.132.02.266.03.4.032h.8v2h.8v-2h1.2v2h.8v-2h1.2v2h.8v-2h1.2v2h.8v-2h1.2v2h.8v-2h1.2v2h.8v-2h1.2v2h.8v-2h.8c.134-.001.268-.012.4-.032V24h.8v-2.274a2.814 2.814 0 001.326-1.326H24v-.8h-2.032c.02-.133.03-.266.032-.4v-.8h2v-.8h-2v-1.2h2v-.8h-2v-1.2h2v-.8h-2v-1.2h2v-.8h-2v-1.2h2v-.8h-2V8.4h2v-.8h-2V6.4h2v-.8h-2v-.8a2.805 2.805 0 00-.032-.4H24v-.8h-2.274A2.814 2.814 0 0020.4 2.274zm.8 16.926a2.003 2.003 0 01-2 2H4.8a2.003 2.003 0 01-2-2V4.8a2.003 2.003 0 012-2h14.4a2.003 2.003 0 012 2v14.4z' fill='#FF7F22')
        path.path(d='M18.8 4H5.2A1.2 1.2 0 004 5.2v13.6A1.2 1.2 0 005.2 20h13.6a1.2 1.2 0 001.2-1.2V5.2A1.2 1.2 0 0018.8 4zm.4 14.8a.4.4 0 01-.4.4H5.2a.4.4 0 01-.4-.4V5.2a.4.4 0 01.4-.4h13.6a.4.4 0 01.4.4v13.6z' fill='#FF7F22')
        path.path(d='M17.6 5.6h.8v.8h-.8v-.8zM5.6 17.6h.8v.8h-.8v-.8zM5.6 6.4v1.2h.8V6.4h1.2v-.8H6.4a.8.8 0 00-.8.8zM17.6 17.6h-1.2v.8h2v-2h-.8v1.2z' fill='#FF7F22')
      div.circle(v-if='checkSoul(detail.alias, index)')
        svg.svg(width='21' height='20' fill='none' xmlns='http://www.w3.org/2000/svg')
          path.path(d='M17.917 5.246c.042-.117.077-.237.106-.358.066-.352.122-.4.472-.393a.22.22 0 00.157-.062c.018-.022-.01-.118-.043-.142-.096-.066-.201-.142-.312-.16-.306-.05-.326-.087-.212-.364.048-.114.038-.254.045-.383.019-.305.187-.546.358-.775.112-.149.342-.056.406.14.028.089.058.176.088.264l.05-.013-.154-.641c.07-.007.11-.023.14-.012.139.048.235 0 .32-.112.06-.08.121-.13.214-.004.363.486.595 1.058.673 1.66.037.258.09.512.159.762.106.406.104.815.08 1.245a7.146 7.146 0 00-.635-1.73l-.044.016c.052.135.102.27.157.405.228.553.199 1.096-.065 1.631-.027.055-.035.119-.06.175-.05.117-.047.255.073.28.077.016.202-.086.27-.165.068-.079.082-.192.129-.286.031-.056.067-.109.107-.159l.067.02c-.017.14-.025.28-.054.418-.037.176-.085.35-.138.522-.053.173-.149.204-.27.088-.122-.115-.268-.21-.299-.41-.015-.1-.133-.186-.205-.279-.066.097-.137.192-.196.293a.167.167 0 00-.009.127c.105.27.13.573.377.785.177.153.104.348-.124.42a.199.199 0 00-.115.121c-.084.382-.4.459-.704.538-.193.044-.39.07-.587.076-.05.003-.143-.056-.151-.1a3.085 3.085 0 01-.07-.552c-.01-.388-.002-.776-.002-1.166.26-.022.324-.098.26-.373-.048-.208-.115-.412-.19-.668l-.252.539c-.087-.106-.17-.175-.21-.261a4.684 4.684 0 01-.293-.742c-.04-.15-.006-.32.014-.478.004-.037.082-.089.132-.095.174-.025.36.103.428.277a.46.46 0 00.047.074l.065.007zm1.621-1.39l.06-.042-.313-.433-.059.043.312.432z' fill='#fff')
          path.path(d='M16.79 3.706c.03-.261.039-.463.08-.656a.627.627 0 01.156-.287c.223-.235.41-.485.522-.8.105-.303.34-.51.687-.502.097 0 .224.056.278.13.035.046-.014.19-.065.261-.171.228-.246.492-.35.75-.208.523-.174 1.082-.319 1.612-.032.117-.127.3-.204.307-.228.017-.51.046-.626-.23-.086-.204-.118-.428-.16-.585zM16.581 14.14c-.021.133-.018.227-.053.303a5.458 5.458 0 01-.33.642c-.08.127-.215.217-.312.335-.142.17-.274.347-.396.531-.136.213-.236.448-.38.655-.1.145-.241.264-.376.38-.2.175-.408.34-.625.493-.106.075-.25.091-.365.155-.095.054-.217.122-.25.212-.095.266-.358.237-.541.343-.003.002-.09-.1-.079-.121.093-.185.198-.363.316-.534.465-.642 1.1-1.116 1.665-1.66.324-.312.62-.653.932-.979.221-.232.445-.461.67-.69.015-.016.04-.022.124-.065zM1.432 3.542c.07.006.11-.003.13.013.184.138.372.273.544.425.068.06.037.13-.058.168-.29.121-.578.252-.868.373-.187.078-.45-.086-.525-.32-.068-.213.038-.376.265-.444.118-.035.228-.098.341-.146.067-.029.135-.055.17-.069zM15.543 17.687l-.602.837c-.153.211-.294.433-.464.63a3.432 3.432 0 01-.49.45c-.08.062-.17.037-.162-.1.006-.086.005-.173.014-.259.02-.186.02-.353.249-.466.22-.11.382-.335.577-.5.24-.2.485-.393.733-.587a.44.44 0 01.112-.046l.033.04zM15.617 16.752c-.112.16-.194.29-.288.414a8.06 8.06 0 01-.402.485c-.027.03-.09.028-.136.041-.02-.072-.078-.165-.052-.213.077-.146.168-.294.288-.403.139-.125.314-.209.476-.308.017-.01.044-.006.114-.016zM1.506 5.627l.071-.22c.077.024.153.054.226.088.085.05.165.106.24.17.033.029.074.082.068.116-.006.034-.062.067-.104.084a.683.683 0 01-.178.042c-.26.027-.307-.016-.323-.28zM3.092 5.403l.166-.572c.203.03.38.187.37.314-.014.193-.17.273-.536.258zM2.756 5.528c.124.02.212.021.288.052a.194.194 0 01.104.127c.005.034-.056.109-.091.112-.087.008-.201.012-.257-.037-.047-.045-.03-.161-.044-.254zM2.38 5.06c.032-.129.044-.26.205-.273.01 0 .05.083.037.112-.037.096-.035.263-.242.16zM3.713 10.367l.247.127c-.022.03-.038.083-.065.088-.124.021-.196-.036-.182-.215zM9.122 2.88c-.061-.08-.115-.134-.108-.144.065-.088.136-.171.213-.249.035.02.066.045.093.075-.052.094-.112.185-.198.318z' fill='#fff')
          path.path(fill-rule='evenodd' clip-rule='evenodd' d='M.302 1.546a1.366 1.366 0 00-.072.164 1.5 1.5 0 00-.053.336c-.005.06-.01.12-.018.178-.021.153.09.366.255.388.075.01.189-.093.247-.173.156-.216.403-.293.622-.321.24-.031.489-.001.736.028l.207.024c.243.025.463.26.537.51.02.065.107.122.174.16.04.022.085.038.13.053a.476.476 0 01.173.087c.387.361.562.84.704 1.33.052.165.073.337.064.509-.032.37-.08.74-.127 1.109a92.051 92.051 0 00-.064.522 4.251 4.251 0 01-.092.583 2.812 2.812 0 01-.142.391 3.52 3.52 0 00-.12.315 3.24 3.24 0 00-.08.35c-.02.102-.04.204-.067.304-.07.254.02.524.259.614a1.865 1.865 0 001.432-.045c.192-.091.404-.13.616-.112.04.004.078.016.117.03.045.014.09.029.135.029.448.008.89.102 1.302.278.1.041.285.003.373-.07.087-.074.154-.255.124-.359-.048-.164.002-.288.053-.417l.027-.071.024.004c.012.002.02.003.024.007.254.357.444.726.328 1.19a.65.65 0 01-.298.424c-.17.102-.347.209-.534.258a2.104 2.104 0 01-.496.048l-.127.002a.144.144 0 01-.108-.084c-.01-.031.03-.091.066-.116a.906.906 0 01.25-.135c.107-.034.201-.063.163-.207-.032-.117-.116-.107-.198-.098a3.012 3.012 0 00-1.243.122c.01.035.022.07.037.103.145.236.135.246-.078.415a.324.324 0 00-.116.23c.005.1.027.198.05.296.013.059.027.117.037.176.031.193-.063.269-.245.24a.412.412 0 00-.283.063c-.094.07-.11.188-.026.299a.211.211 0 01.027.086l.046.23c.033.17.066.34.11.505.034.13.121.244.28.217.154-.026.304-.083.259-.287a4.77 4.77 0 00-.165-.596c-.062-.172.045-.253.154-.312.132-.071.198.043.255.142l.001.002.03.052c.043.073.085.145.124.22.018.033.038.066.058.099.054.09.108.181.12.277.025.207.127.231.301.223a71.59 71.59 0 011.53-.046l.048-.001c.064-.002.129.002.193.006.097.006.194.011.288-.002.245-.038.486-.088.725-.151.07-.017.137-.042.204-.067.057-.021.114-.042.173-.059.188-.052.378-.1.57-.138a.271.271 0 01.13.023l.047.015c.14.037.278.075.416.117.021.007.043.012.065.017.066.017.134.033.176.074.204.197.39.407.577.62a.169.169 0 01.012.151c-.018.038-.09.083-.126.075-.133-.03-.262-.069-.39-.108l-.12-.036a.864.864 0 00-.158-.05 1.554 1.554 0 00-.962.2c-.113.071-.235.13-.361.175-.312.099-.619.204-.887.4-.064.047-.145.099-.217.097-.184-.004-.335.039-.41.217a3.23 3.23 0 00-.153.485c-.01.041.036.104.07.146.138.169.335.195.524.151.138-.032.194.01.212.122.022.153.035.307.04.461.009.141-.06.214-.206.233-.109.014-.215.045-.315.093a1.394 1.394 0 00-.34.213c-.03.028-.077.046-.123.065-.117.045-.235.092-.122.294a.628.628 0 01-.103.034c-.103.028-.204.056-.179.204.032.185-.076.242-.21.264-.195.032-.207.134-.158.293.05.164.098.33.145.495.043.147.085.295.13.442.006.021.03.037.054.053l.032.023c.009-.013.02-.026.032-.04.024-.027.049-.056.049-.085.005-.132.005-.264.006-.396.001-.123.002-.245.006-.367.001-.037.02-.072.04-.108a.608.608 0 00.025-.05c.049.03.095.064.14.1l.123.12c.073.071.146.143.226.205.083.062.12.11.083.214-.09.249-.066.291.202.332.098.01.197.008.295-.006.096-.008.192-.02.288-.032.142-.017.283-.034.425-.042.045-.003.09.02.137.044a.599.599 0 00.08.036l.076.032c.067.03.135.06.175.04.144-.077.294-.178.382-.309.083-.124.152-.135.284-.127a1.75 1.75 0 00.472-.057c.072-.016.14-.048.21-.08.033-.015.066-.03.1-.043.035-.015.076-.026.117-.037.09-.025.178-.05.207-.105a.706.706 0 01.326-.31.5.5 0 00.174-.186c.046-.08.046-.165-.065-.212-.224-.093-.236-.14-.064-.317.044-.046.106-.075.168-.105l.061-.03c.066-.036.133-.07.2-.104.085-.043.17-.086.253-.131.044-.024.087-.051.13-.079a1.321 1.321 0 01.301-.151c.195-.073.386-.144.48-.361.01-.021.03-.037.052-.052l.03-.023.113-.101c.094-.083.188-.166.273-.257.088-.092.144-.088.192.024.027.063.049.13.074.205l.04.116c.1-.308.24-.552.5-.712a.127.127 0 00.05-.095c.002-.148.101-.229.199-.308l.021-.017.072-.056c.09-.068.182-.138.211-.227.073-.216.12-.442.165-.667l.046-.22a.372.372 0 00.006-.083c0-.028 0-.056.006-.083.021-.09.044-.178.067-.266.082-.316.164-.633.162-.965a23.48 23.48 0 00-.028-1.075c-.002-.048-.075-.103-.127-.135-.119-.072-.204-.148-.18-.31.008-.06-.007-.123-.02-.177a.78.78 0 01-.014-.06h-.301l.021-.087a1.909 1.909 0 01.115-.36c.054-.129.107-.256.09-.374-.025-.162-.105-.316-.184-.47a3.771 3.771 0 01-.102-.209l-.033-.07a.527.527 0 01-.067-.191 21.908 21.908 0 01-.038-1.072c-.001-.11.004-.221.01-.332.005-.098.01-.197.01-.295l.002-.077c.001-.124.004-.254-.045-.356-.07-.148-.048-.231.068-.32a.47.47 0 00.183-.347c.016-.133.05-.263.085-.394.016-.058.031-.117.045-.176a.145.145 0 00.006-.07 10.48 10.48 0 00-.063-.2 11.705 11.705 0 01-.052-.168c-.097-.313-.002-.647.229-.726.12-.042.148-.102.154-.214.006-.12.016-.238.026-.356.01-.122.02-.243.027-.365a.268.268 0 00-.03-.11.556.556 0 01-.023-.062l-.024-.079c-.022-.066-.043-.133-.047-.2l-.005-.095c-.006-.128-.012-.257-.029-.382-.53-.37-1.447-.82-2.989-1.136h-.527c.132.143.226.316.273.505.017.064.086.113.164.169.037.027.077.055.113.087a.636.636 0 00-.053.029c-.04.022-.076.044-.096.033a1.38 1.38 0 01-.35-.228 6.98 6.98 0 01-.387-.425c-.05-.057-.099-.115-.15-.171H8.426L8.19.464c-.22.078-.439.157-.656.239-.045.017-.086.043-.128.07a.628.628 0 01-.143.075l-.017.005c-.199.063-.4.127-.606.152-.131.016-.265.015-.399.014-.095-.001-.19-.002-.285.004-.027.001-.053.026-.08.052a.274.274 0 01-.058.049h-.001c-.05.027-.12.065-.16.048-.053-.023-.125-.101-.119-.146.015-.11.518-.46 1.015-.806.107-.074.214-.148.315-.22C2.976.126 1.134.95.302 1.546zm9.769.671c.069.009.138.012.207.012l-.254-.274.025-.044.866.299c.006.002.015.006.015.01l.055.162c.047.136.094.272.125.412.014.06.002.128-.012.202a1.536 1.536 0 00-.019.112c-.308.178-.568.14-.81-.143-.092-.108-.184-.112-.288-.022l-.009.007c-.011.009-.023.018-.028.03-.099.266-.332.334-.559.402l-.101.03a.434.434 0 01-.319-.032 2.54 2.54 0 01-.48-.373c-.115-.112-.218-.134-.344-.046-.168.118-.329.244-.355.474a.509.509 0 00.426.57.351.351 0 01.08.038c-.167.211-.32.23-.56.065a2.663 2.663 0 01-.036-.025c-.108-.076-.194-.137-.362-.032-.23.144-.405.005-.41-.266-.002-.073-.006-.146-.01-.219-.006-.093-.011-.186-.011-.28 0-.066.016-.131.048-.19.03-.05.065-.097.1-.144.033-.043.065-.085.093-.13.284-.465.707-.74 1.216-.897.012-.004.026.001.047.008a.524.524 0 00.041.014l-.21.186.004.031.005.031.15.01c.112.009.222.017.331.007l.015-.002c.443-.042.885-.084 1.328.007z' fill='#fff')
</template>

<script lang='ts'>
import { Vue, Component, Prop } from 'vue-property-decorator'

import { PurseModule } from '../../store/modules/purse/index'
import { ProductionModule } from '../../store/modules/production/index'
import IDetail from '../../store/modules/production/interfaces'

@Component
export default class DetailsProduction extends Vue {
  @Prop() detail!: IDetail
  @Prop() color!: string

  get details () {
    return ProductionModule.details
  }

  get coins () {
    return PurseModule.coins
  }

  get colorLocal () {
    return this.color
  }

  set colorLocal (value) {
    this.$emit('update:color', value)
  }

  get isAllDetailsEnough (): boolean {
    if (this.coins < 10) {
      return false
    }
    for (const i in this.details) {
      if (this.details[i].installed.filter((j: boolean) => j === true).length !== this.details[i].need) {
        return false
      }
    }
    return true
  }

  isHaveDetails (detail: IDetail, index: number): boolean {
    return detail.quantityStock + detail.quantityProduction <= index
  }

  handleClickDetail (detail: IDetail, index: number) {
    if (!detail.installed[index]) {
      ProductionModule.onProduction({ detail, index })
      if (this.isAllDetailsEnough === true) {
        this.colorLocal = 'grey'
      }
    } else {
      ProductionModule.takeOffProduction({ detail, index })
      this.colorLocal = 'black'
    }
  }

  checkBiomechanism (alias: string): boolean {
    return alias === 'biomechanism'
  }

  checkProcessor (alias: string): boolean {
    return alias === 'processor'
  }

  checkSoul (alias: string): boolean {
    return alias === 'soul'
  }
}
</script>

<style lang="scss" scoped>
@import '../../assets/styles/config/variables.scss';

.icon {
  width: $detail-production-width;
  height: $detail-production-height;

  background: none;

  background-repeat: no-repeat;

  background-size: 36px 24px;
  border: 2px solid $main-orange-color;
  border-radius: 4px;

  cursor: pointer;

  &:not(:first-child) {
    margin-left: 10px;
  }

  &:not(:last-child) {
    margin-bottom: 16px;
  }

  &:disabled {
    background-color: #333940;
    border-color: #333940;

    .circle {
      .svg {
        .path {
          fill: $disable-button-background-color;
        }
      }
    }
  }

  .circle {
    margin-left: 6px;
    width: 32px;
    height: 32px;
    border: 1px solid $main-orange-color;
    border-radius: 60px;

    .svg {
      margin-top: 6px;
      .path {
        fill: $main-orange-color;
      }
    }
  }
}

.icon-not-pressed {
  background-color: #333940;
  border-color: #333940;

  &:disabled {
    background-color: #333940;
    .circle {
      border: 1px solid $disable-button-background-color;
      .svg {
        .path {
          fill: $disable-button-background-color;
        }
      }
    }
    .svg {
      .path {
        fill: $disable-button-background-color;
      }
    }
  }

  .svg {
    .path {
      fill: $main-font-color;
    }
  }

  .circle {
    width: 32px;
    height: 32px;
    border: 1px solid #FFFFFF;
    border-radius: 60px;

    .svg {
      .path {
        fill: $main-font-color;
      }
    }
  }
}
</style>
